//////////////////////////////////////////////////////////////////////////
// EasyX : A very simple DirectX Interface (for DOS-like programmers)   //
//                                                                      //
// Created by "Serkan YAZICI", 4 October 1997, Manchester               //
// Completely Freeware Source Code. Use It, Modify It as you wish       //
//                                                                      //
// Comments, Bugs, Credits welcomed...                                  //
//                   mchu4sy1@fs2.ee.umist.ac.uk                        //
//                                                                      //
//                           VERSION 1.0                                //
//////////////////////////////////////////////////////////////////////////


#include "EasyX.hpp"


void DemoTimer(void)
{
  //Triangle demo
  short x1=rand()%100+270, x2=rand()%100+270, x3=rand()%100+270;
  short y1=rand()%100, y2=rand()%100, y3=rand()%100;
  for(short i=0; i<100; i++)
    memset(surface+i*640+270,i,100);
  DRAW::Line(x1,y1,x2,y2,255);
  DRAW::Line(x1,y1,x3,y3,255);
  DRAW::Line(x2,y2,x3,y3,255);
  VDU::Update(270,0,370,100);
}


void Main(void)
{
  //------------------------------------------------------------//
  // Your program starts here, you're currently in the graphics //
  // mode (640x480x8 default) and everything is ready...        //
  //------------------------------------------------------------//
  BYTE color=0;
  
  //Set Palette Values with 64 shades of red, green, blue and gray
  for(short i=0; i<64; i++){
    PALETTE::SetReg(i,i,0,0);
    PALETTE::SetReg(i+64,0,i,0);
    PALETTE::SetReg(i+128,0,0,i);
    PALETTE::SetReg(i+192,i,i,i);
  }
  
  //Draw Lines by (mem)setting the *surface
  for(i=0; i<480; i++)
    memset(surface + i*640, i, 640);
  VDU::UpdateAll();
  
  //Install a timer (18.2 times/sec)
  TIMER::InstallSecondary(DemoTimer);
  
  //Wait until the user presses [ESC] key
  //**Note this a input loop, therefore call IDLE continuously
  //(otherwise no input is provided + Windows doesn't response)**
  while(KEY::Get() != 27){
    IDLE;
    //Glowing rect
    for(i=0; i<64; i++)
      DRAW::Rectangle(256+i,256+i,384-i,384-i,color+i);
    VDU::Update(256,256,384,384);
    //Shifting colors
    for(i=0; i<480; i++){
      DRAW::HLine(0,i,140,255-color+i);
      DRAW::HLine(500,i,140,color+i);
    }
    VDU::Update(500,0,639,479);
    VDU::Update(0,0,139,479);
      
    color++;
  }
  //-----------------------------------------------------------//
  // End of the program                                        //
  //-----------------------------------------------------------//
}

